//
// PointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PointsAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case cldcvrmin = "cldCvrMin"
        case cldcvravg = "cldCvrAvg"
        case cldcvrmax = "cldCvrMax"
        case dewptmin = "dewPtMin"
        case dewptavg = "dewPtAvg"
        case dewptmax = "dewPtMax"
        case feelslikemin = "feelsLikeMin"
        case feelslikeavg = "feelsLikeAvg"
        case feelslikemax = "feelsLikeMax"
        case heatindexmin = "heatIndexMin"
        case heatindexavg = "heatIndexAvg"
        case heatindexmax = "heatIndexMax"
        case mslpresmin = "mslPresMin"
        case mslpresavg = "mslPresAvg"
        case mslpresmax = "mslPresMax"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolarmin = "radSolarMin"
        case radsolaravg = "radSolarAvg"
        case radsolarmax = "radSolarMax"
        case radsolartot = "radSolarTot"
        case relhummin = "relHumMin"
        case relhumavg = "relHumAvg"
        case relhummax = "relHumMax"
        case sfcpresmin = "sfcPresMin"
        case sfcpresavg = "sfcPresAvg"
        case sfcpresmax = "sfcPresMax"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchummin = "spcHumMin"
        case spchumavg = "spcHumAvg"
        case spchummax = "spcHumMax"
        case tempmin = "tempMin"
        case tempavg = "tempAvg"
        case tempmax = "tempMax"
        case wetbulbmin = "wetBulbMin"
        case wetbulbavg = "wetBulbAvg"
        case wetbulbmax = "wetBulbMax"
        case windchillmin = "windChillMin"
        case windchillavg = "windChillAvg"
        case windchillmax = "windChillMax"
        case winddiravg = "windDirAvg"
        case winddir80mavg = "windDir80mAvg"
        case winddir100mavg = "windDir100mAvg"
        case windspdmin = "windSpdMin"
        case windspdavg = "windSpdAvg"
        case windspdmax = "windSpdMax"
        case windspd80mmin = "windSpd80mMin"
        case windspd80mavg = "windSpd80mAvg"
        case windspd80mmax = "windSpd80mMax"
        case windspd100mmin = "windSpd100mMin"
        case windspd100mavg = "windSpd100mAvg"
        case windspd100mmax = "windSpd100mMax"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeDaysDateGet(latitude: Float, longitude: Float, date: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateGet? = nil, completion: @escaping ((_ data: ForecastPointDayObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeDaysDateGetWithRequestBuilder(latitude: latitude, longitude: longitude, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+0000",
    "dateEnd" : "2019-12-20T00:00:00.000+0000"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  }, {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvrAvg" : "Percent value in [0,100]",
      "cldCvrMax" : "Percent value in [0,100]",
      "cldCvrMin" : "Percent value in [0,100]",
      "dewPtAvg" : "Fahrenheit",
      "dewPtMax" : "Fahrenheit",
      "dewPtMin" : "Fahrenheit",
      "feelsLikeAvg" : "Fahrenheit",
      "feelsLikeMax" : "Fahrenheit",
      "feelsLikeMin" : "Fahrenheit",
      "heatIndexAvg" : "Fahrenheit",
      "heatIndexMax" : "Fahrenheit",
      "heatIndexMin" : "Fahrenheit",
      "mslPresAvg" : "Millibars",
      "mslPresMax" : "Millibars",
      "mslPresMin" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolarAvg" : "Watts per Square Meter",
      "radSolarMax" : "Watts per Square Meter",
      "radSolarMin" : "Watts per Square Meter",
      "radSolarTot" : "Watts per Square Meter",
      "relHumAvg" : "Percent value in [0,100]",
      "relHumMax" : "Percent value in [0,100]",
      "relHumMin" : "Percent value in [0,100]",
      "sfcPresAvg" : "Millibars",
      "sfcPresMax" : "Millibars",
      "sfcPresMin" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHumAvg" : "Grams of Moisture per Kilograms of Air",
      "spcHumMax" : "Grams of Moisture per Kilograms of Air",
      "spcHumMin" : "Grams of Moisture per Kilograms of Air",
      "tempAvg" : "Fahrenheit",
      "tempMax" : "Fahrenheit",
      "tempMin" : "Fahrenheit",
      "wetBulbAvg" : "Fahrenheit",
      "wetBulbMax" : "Fahrenheit",
      "wetBulbMin" : "Fahrenheit",
      "windChillAvg" : "Fahrenheit",
      "windChillMax" : "Fahrenheit",
      "windChillMin" : "Fahrenheit",
      "windDir100mAvg" : "Degrees [0,360] (0 = North)",
      "windDir80mAvg" : "Degrees [0,360] (0 = North)",
      "windDirAvg" : "Degrees [0,360] (0 = North)",
      "windSpd100mAvg" : "Miles per Hour",
      "windSpd100mMax" : "Miles per Hour",
      "windSpd100mMin" : "Miles per Hour",
      "windSpd80mAvg" : "Miles per Hour",
      "windSpd80mMax" : "Miles per Hour",
      "windSpd80mMin" : "Miles per Hour",
      "windSpdAvg" : "Miles per Hour",
      "windSpdMax" : "Miles per Hour",
      "windSpdMin" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointDayObj> 
     */
    open class func pointsLatitudelongitudeDaysDateGetWithRequestBuilder(latitude: Float, longitude: Float, date: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateGet? = nil) -> RequestBuilder<ForecastPointDayObj> {
        var path = "/points/{latitude},{longitude}/days/{date}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case cldcvrmin = "cldCvrMin"
        case cldcvravg = "cldCvrAvg"
        case cldcvrmax = "cldCvrMax"
        case dewptmin = "dewPtMin"
        case dewptavg = "dewPtAvg"
        case dewptmax = "dewPtMax"
        case feelslikemin = "feelsLikeMin"
        case feelslikeavg = "feelsLikeAvg"
        case feelslikemax = "feelsLikeMax"
        case heatindexmin = "heatIndexMin"
        case heatindexavg = "heatIndexAvg"
        case heatindexmax = "heatIndexMax"
        case mslpresmin = "mslPresMin"
        case mslpresavg = "mslPresAvg"
        case mslpresmax = "mslPresMax"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolarmin = "radSolarMin"
        case radsolaravg = "radSolarAvg"
        case radsolarmax = "radSolarMax"
        case radsolartot = "radSolarTot"
        case relhummin = "relHumMin"
        case relhumavg = "relHumAvg"
        case relhummax = "relHumMax"
        case sfcpresmin = "sfcPresMin"
        case sfcpresavg = "sfcPresAvg"
        case sfcpresmax = "sfcPresMax"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchummin = "spcHumMin"
        case spchumavg = "spcHumAvg"
        case spchummax = "spcHumMax"
        case tempmin = "tempMin"
        case tempavg = "tempAvg"
        case tempmax = "tempMax"
        case wetbulbmin = "wetBulbMin"
        case wetbulbavg = "wetBulbAvg"
        case wetbulbmax = "wetBulbMax"
        case windchillmin = "windChillMin"
        case windchillavg = "windChillAvg"
        case windchillmax = "windChillMax"
        case winddiravg = "windDirAvg"
        case winddir80mavg = "windDir80mAvg"
        case winddir100mavg = "windDir100mAvg"
        case windspdmin = "windSpdMin"
        case windspdavg = "windSpdAvg"
        case windspdmax = "windSpdMax"
        case windspd80mmin = "windSpd80mMin"
        case windspd80mavg = "windSpd80mAvg"
        case windspd80mmax = "windSpd80mMax"
        case windspd100mmin = "windSpd100mMin"
        case windspd100mavg = "windSpd100mAvg"
        case windspd100mmax = "windSpd100mMax"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeDaysDateStartdateEndGet(latitude: Float, longitude: Float, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: ForecastPointDayObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeDaysDateStartdateEndGetWithRequestBuilder(latitude: latitude, longitude: longitude, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+0000",
    "dateEnd" : "2019-12-20T00:00:00.000+0000"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  }, {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvrAvg" : "Percent value in [0,100]",
      "cldCvrMax" : "Percent value in [0,100]",
      "cldCvrMin" : "Percent value in [0,100]",
      "dewPtAvg" : "Fahrenheit",
      "dewPtMax" : "Fahrenheit",
      "dewPtMin" : "Fahrenheit",
      "feelsLikeAvg" : "Fahrenheit",
      "feelsLikeMax" : "Fahrenheit",
      "feelsLikeMin" : "Fahrenheit",
      "heatIndexAvg" : "Fahrenheit",
      "heatIndexMax" : "Fahrenheit",
      "heatIndexMin" : "Fahrenheit",
      "mslPresAvg" : "Millibars",
      "mslPresMax" : "Millibars",
      "mslPresMin" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolarAvg" : "Watts per Square Meter",
      "radSolarMax" : "Watts per Square Meter",
      "radSolarMin" : "Watts per Square Meter",
      "radSolarTot" : "Watts per Square Meter",
      "relHumAvg" : "Percent value in [0,100]",
      "relHumMax" : "Percent value in [0,100]",
      "relHumMin" : "Percent value in [0,100]",
      "sfcPresAvg" : "Millibars",
      "sfcPresMax" : "Millibars",
      "sfcPresMin" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHumAvg" : "Grams of Moisture per Kilograms of Air",
      "spcHumMax" : "Grams of Moisture per Kilograms of Air",
      "spcHumMin" : "Grams of Moisture per Kilograms of Air",
      "tempAvg" : "Fahrenheit",
      "tempMax" : "Fahrenheit",
      "tempMin" : "Fahrenheit",
      "wetBulbAvg" : "Fahrenheit",
      "wetBulbMax" : "Fahrenheit",
      "wetBulbMin" : "Fahrenheit",
      "windChillAvg" : "Fahrenheit",
      "windChillMax" : "Fahrenheit",
      "windChillMin" : "Fahrenheit",
      "windDir100mAvg" : "Degrees [0,360] (0 = North)",
      "windDir80mAvg" : "Degrees [0,360] (0 = North)",
      "windDirAvg" : "Degrees [0,360] (0 = North)",
      "windSpd100mAvg" : "Miles per Hour",
      "windSpd100mMax" : "Miles per Hour",
      "windSpd100mMin" : "Miles per Hour",
      "windSpd80mAvg" : "Miles per Hour",
      "windSpd80mMax" : "Miles per Hour",
      "windSpd80mMin" : "Miles per Hour",
      "windSpdAvg" : "Miles per Hour",
      "windSpdMax" : "Miles per Hour",
      "windSpdMin" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointDayObj> 
     */
    open class func pointsLatitudelongitudeDaysDateStartdateEndGetWithRequestBuilder(latitude: Float, longitude: Float, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysDateStartdateEndGet? = nil) -> RequestBuilder<ForecastPointDayObj> {
        var path = "/points/{latitude},{longitude}/days/{dateStart},{dateEnd}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeDaysGet: String { 
        case timestampinit = "timestampInit"
        case cldcvrmin = "cldCvrMin"
        case cldcvravg = "cldCvrAvg"
        case cldcvrmax = "cldCvrMax"
        case dewptmin = "dewPtMin"
        case dewptavg = "dewPtAvg"
        case dewptmax = "dewPtMax"
        case feelslikemin = "feelsLikeMin"
        case feelslikeavg = "feelsLikeAvg"
        case feelslikemax = "feelsLikeMax"
        case heatindexmin = "heatIndexMin"
        case heatindexavg = "heatIndexAvg"
        case heatindexmax = "heatIndexMax"
        case mslpresmin = "mslPresMin"
        case mslpresavg = "mslPresAvg"
        case mslpresmax = "mslPresMax"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolarmin = "radSolarMin"
        case radsolaravg = "radSolarAvg"
        case radsolarmax = "radSolarMax"
        case radsolartot = "radSolarTot"
        case relhummin = "relHumMin"
        case relhumavg = "relHumAvg"
        case relhummax = "relHumMax"
        case sfcpresmin = "sfcPresMin"
        case sfcpresavg = "sfcPresAvg"
        case sfcpresmax = "sfcPresMax"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchummin = "spcHumMin"
        case spchumavg = "spcHumAvg"
        case spchummax = "spcHumMax"
        case tempmin = "tempMin"
        case tempavg = "tempAvg"
        case tempmax = "tempMax"
        case wetbulbmin = "wetBulbMin"
        case wetbulbavg = "wetBulbAvg"
        case wetbulbmax = "wetBulbMax"
        case windchillmin = "windChillMin"
        case windchillavg = "windChillAvg"
        case windchillmax = "windChillMax"
        case winddiravg = "windDirAvg"
        case winddir80mavg = "windDir80mAvg"
        case winddir100mavg = "windDir100mAvg"
        case windspdmin = "windSpdMin"
        case windspdavg = "windSpdAvg"
        case windspdmax = "windSpdMax"
        case windspd80mmin = "windSpd80mMin"
        case windspd80mavg = "windSpd80mAvg"
        case windspd80mmax = "windSpd80mMax"
        case windspd100mmin = "windSpd100mMin"
        case windspd100mavg = "windSpd100mAvg"
        case windspd100mmax = "windSpd100mMax"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily forecast for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeDaysGet(latitude: Float, longitude: Float, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysGet? = nil, completion: @escaping ((_ data: ForecastPointDayObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeDaysGetWithRequestBuilder(latitude: latitude, longitude: longitude, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily forecast for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+0000",
    "dateEnd" : "2019-12-20T00:00:00.000+0000"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  }, {
    "date" : "2019-12-20T00:00:00.000+0000",
    "cldCvrMin" : 22,
    "cldCvrAvg" : 78,
    "windSpdMax" : 5.1,
    "heatIndexMax" : 55.3,
    "radSolarMax" : 436.5,
    "wetBulbMin" : 39.5,
    "wetBulbAvg" : 47,
    "tempMax" : 55.3,
    "sfcPresMax" : 1020.8,
    "radSolarMin" : 0,
    "radSolarAvg" : 84.3,
    "wetBulbMax" : 51,
    "feelsLikeMax" : 55.2,
    "radSolarTot" : 2023.1,
    "windSpd80mAvg" : 6.8,
    "windSpd80mMin" : 1.4,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "windSpd80mMax" : 11.6,
    "windSpd100mAvg" : 7.2,
    "dewPtMax" : 50.6,
    "spcHumMin" : 4,
    "spcHumAvg" : 6,
    "windSpdMin" : 0.3,
    "windSpdAvg" : 2.3,
    "windDir100mAvg" : 334,
    "windChillMax" : 55.2,
    "tempMin" : 43.5,
    "tempAvg" : 50.2,
    "windSpd100mMin" : 1.7,
    "dewPtMin" : 33.8,
    "dewPtAvg" : 43.5,
    "spcHumMax" : 7.7,
    "windSpd100mMax" : 12.1,
    "windChillAvg" : 49.8,
    "snowfall" : 0,
    "windChillMin" : 42.3,
    "windDirAvg" : 354,
    "precipProb" : 0,
    "relHumMax" : 98,
    "precip" : 0,
    "relHumMin" : 62.1,
    "relHumAvg" : 79,
    "mslPresMin" : 1017.9,
    "mslPresAvg" : 1020,
    "snowfallProb" : 0,
    "sfcPresMin" : 1015.6,
    "sfcPresAvg" : 1018.3,
    "cldCvrMax" : 100,
    "windDir80mAvg" : 334,
    "mslPresMax" : 1021.9,
    "feelsLikeMin" : 42.3,
    "feelsLikeAvg" : 49.8,
    "heatIndexMin" : 43.5,
    "heatIndexAvg" : 50.2
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvrAvg" : "Percent value in [0,100]",
      "cldCvrMax" : "Percent value in [0,100]",
      "cldCvrMin" : "Percent value in [0,100]",
      "dewPtAvg" : "Fahrenheit",
      "dewPtMax" : "Fahrenheit",
      "dewPtMin" : "Fahrenheit",
      "feelsLikeAvg" : "Fahrenheit",
      "feelsLikeMax" : "Fahrenheit",
      "feelsLikeMin" : "Fahrenheit",
      "heatIndexAvg" : "Fahrenheit",
      "heatIndexMax" : "Fahrenheit",
      "heatIndexMin" : "Fahrenheit",
      "mslPresAvg" : "Millibars",
      "mslPresMax" : "Millibars",
      "mslPresMin" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolarAvg" : "Watts per Square Meter",
      "radSolarMax" : "Watts per Square Meter",
      "radSolarMin" : "Watts per Square Meter",
      "radSolarTot" : "Watts per Square Meter",
      "relHumAvg" : "Percent value in [0,100]",
      "relHumMax" : "Percent value in [0,100]",
      "relHumMin" : "Percent value in [0,100]",
      "sfcPresAvg" : "Millibars",
      "sfcPresMax" : "Millibars",
      "sfcPresMin" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHumAvg" : "Grams of Moisture per Kilograms of Air",
      "spcHumMax" : "Grams of Moisture per Kilograms of Air",
      "spcHumMin" : "Grams of Moisture per Kilograms of Air",
      "tempAvg" : "Fahrenheit",
      "tempMax" : "Fahrenheit",
      "tempMin" : "Fahrenheit",
      "wetBulbAvg" : "Fahrenheit",
      "wetBulbMax" : "Fahrenheit",
      "wetBulbMin" : "Fahrenheit",
      "windChillAvg" : "Fahrenheit",
      "windChillMax" : "Fahrenheit",
      "windChillMin" : "Fahrenheit",
      "windDir100mAvg" : "Degrees [0,360] (0 = North)",
      "windDir80mAvg" : "Degrees [0,360] (0 = North)",
      "windDirAvg" : "Degrees [0,360] (0 = North)",
      "windSpd100mAvg" : "Miles per Hour",
      "windSpd100mMax" : "Miles per Hour",
      "windSpd100mMin" : "Miles per Hour",
      "windSpd80mAvg" : "Miles per Hour",
      "windSpd80mMax" : "Miles per Hour",
      "windSpd80mMin" : "Miles per Hour",
      "windSpdAvg" : "Miles per Hour",
      "windSpdMax" : "Miles per Hour",
      "windSpdMin" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)* * allCldCvr *(derivatives of cldCvr)* * allHum *(derivatives of relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(derivatives of mslPres, sfcPres)* * allRad *(derivatives of radSolar)* * allTemp *(derivatives of dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(derivatives of windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(derivatives of cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointDayObj> 
     */
    open class func pointsLatitudelongitudeDaysGetWithRequestBuilder(latitude: Float, longitude: Float, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeDaysGet? = nil) -> RequestBuilder<ForecastPointDayObj> {
        var path = "/points/{latitude},{longitude}/days"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHoursGet: String { 
        case timestampinit = "timestampInit"
        case cldcvr = "cldCvr"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case heatindex = "heatIndex"
        case mslpres = "mslPres"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolar = "radSolar"
        case relhum = "relHum"
        case sfcpres = "sfcPres"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchum = "spcHum"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case windchill = "windChill"
        case winddir = "windDir"
        case winddir80m = "windDir80m"
        case winddir100m = "windDir100m"
        case windspd = "windSpd"
        case windspd80m = "windSpd80m"
        case windspd100m = "windSpd100m"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly forecast for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHoursGet(latitude: Float, longitude: Float, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursGet? = nil, completion: @escaping ((_ data: ForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHoursGetWithRequestBuilder(latitude: latitude, longitude: longitude, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly forecast for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvr" : "Percent value in [0,100]",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "mslPres" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "relHum" : "Percent value in [0,100]",
      "sfcPres" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "windDir" : "Degrees [0,360] (0 = North)",
      "windDir100m" : "Degrees [0,360] (0 = North)",
      "windDir80m" : "Degrees [0,360] (0 = North)",
      "windSpd" : "Miles per Hour",
      "windSpd100m" : "Miles per Hour",
      "windSpd80m" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHoursGetWithRequestBuilder(latitude: Float, longitude: Float, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursGet? = nil) -> RequestBuilder<ForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/hours"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case cldcvr = "cldCvr"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case heatindex = "heatIndex"
        case mslpres = "mslPres"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolar = "radSolar"
        case relhum = "relHum"
        case sfcpres = "sfcPres"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchum = "spcHum"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case windchill = "windChill"
        case winddir = "windDir"
        case winddir80m = "windDir80m"
        case winddir100m = "windDir100m"
        case windspd = "windSpd"
        case windspd80m = "windSpd80m"
        case windspd100m = "windSpd100m"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHoursTimestampGet(latitude: Float, longitude: Float, timestamp: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampGet? = nil, completion: @escaping ((_ data: ForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHoursTimestampGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvr" : "Percent value in [0,100]",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "mslPres" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "relHum" : "Percent value in [0,100]",
      "sfcPres" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "windDir" : "Degrees [0,360] (0 = North)",
      "windDir100m" : "Degrees [0,360] (0 = North)",
      "windDir80m" : "Degrees [0,360] (0 = North)",
      "windSpd" : "Miles per Hour",
      "windSpd100m" : "Miles per Hour",
      "windSpd80m" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHoursTimestampGetWithRequestBuilder(latitude: Float, longitude: Float, timestamp: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampGet? = nil) -> RequestBuilder<ForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/hours/{timestamp}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

    /**
     * enum for parameter fields
     */
    public enum Fields_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case cldcvr = "cldCvr"
        case dewpt = "dewPt"
        case feelslike = "feelsLike"
        case heatindex = "heatIndex"
        case mslpres = "mslPres"
        case precip = "precip"
        case precipprob = "precipProb"
        case radsolar = "radSolar"
        case relhum = "relHum"
        case sfcpres = "sfcPres"
        case snowfall = "snowfall"
        case snowfallprob = "snowfallProb"
        case spchum = "spcHum"
        case temp = "temp"
        case wetbulb = "wetBulb"
        case windchill = "windChill"
        case winddir = "windDir"
        case winddir80m = "windDir80m"
        case winddir100m = "windDir100m"
        case windspd = "windSpd"
        case windspd80m = "windSpd80m"
        case windspd100m = "windSpd100m"
        case all = "all"
        case allcldcvr = "allCldCvr"
        case allhum = "allHum"
        case allprecip = "allPrecip"
        case allpres = "allPres"
        case allrad = "allRad"
        case alltemp = "allTemp"
        case allwind = "allWind"
        case popular = "popular"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly forecast data for a Latitude/Longitude point.

     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func pointsLatitudelongitudeHoursTimestampStarttimestampEndGet(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: ForecastPointHourObj?,_ error: Error?) -> Void)) {
        pointsLatitudelongitudeHoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: latitude, longitude: longitude, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly forecast data for a Latitude/Longitude point.
     - GET /points/{latitude},{longitude}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "boundingPoints" : [ {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    }, {
      "onpointId" : 10725864,
      "distance" : 2.6772,
      "grid" : "NORTH_AMERICA_GRID"
    } ],
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "radSolar" : 0,
    "snowfallProb" : 0,
    "temp" : 46.75,
    "windChill" : 46.75,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "snowfall" : 0,
    "heatIndex" : 46.75,
    "dewPt" : 45.92,
    "mslPres" : 1017.46,
    "precipProb" : 0,
    "windDir" : 302.6,
    "relHum" : 96.87,
    "wetBulb" : 46.32,
    "spcHum" : 6.49,
    "feelsLike" : 46.75,
    "windSpd" : 0.84,
    "precip" : 0,
    "cldCvr" : 100,
    "sfcPres" : 1013.83,
    "windSpd80m" : 4.38,
    "windDir80m" : 111.89,
    "windDir100m" : 148.96,
    "windSpd100m" : 6.66,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "cldCvr" : "Percent value in [0,100]",
      "dewPt" : "Fahrenheit",
      "feelsLike" : "Fahrenheit",
      "heatIndex" : "Fahrenheit",
      "mslPres" : "Millibars",
      "precip" : "Inches",
      "precipProb" : "Percent value in [0,100]",
      "radSolar" : "Watts per Square Meter",
      "relHum" : "Percent value in [0,100]",
      "sfcPres" : "Millibars",
      "snowfall" : "Inches",
      "snowfallProb" : "Percent value in [0,100]",
      "spcHum" : "Grams of Moisture per Kilograms of Air",
      "temp" : "Fahrenheit",
      "wetBulb" : "Fahrenheit",
      "windChill" : "Fahrenheit",
      "windDir" : "Degrees [0,360] (0 = North)",
      "windDir100m" : "Degrees [0,360] (0 = North)",
      "windDir80m" : "Degrees [0,360] (0 = North)",
      "windSpd" : "Miles per Hour",
      "windSpd100m" : "Miles per Hour",
      "windSpd80m" : "Miles per Hour"
    }
  }
}}]
     - parameter latitude: (path) A latitude value between -90° and 90°. 
     - parameter longitude: (path) A longitude value between -180° (West) and 180° (East). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)* * allCldCvr *(cldCvr)* * allHum *(relHum, spcHum)* * allPrecip *(precip, precipProb, snowfall, snowfallProb)* * allPres *(mslPres, sfcPres)* * allRad *(radSolar)* * allTemp *(dewPt, feelsLike, heatIndex, temp, wetBulb, windChill)* * allWind *(windDir, windDir80m, windDir100m, windSpd, windSpd80m, windSpd100m)* * popular *(cldCvr, feelsLike, precip, relHum, snowfall, temp, windDir, windSpd)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<ForecastPointHourObj> 
     */
    open class func pointsLatitudelongitudeHoursTimestampStarttimestampEndGetWithRequestBuilder(latitude: Float, longitude: Float, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_pointsLatitudelongitudeHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<ForecastPointHourObj> {
        var path = "/points/{latitude},{longitude}/hours/{timestampStart},{timestampEnd}"
        let latitudePreEscape = "\(latitude)"
        let latitudePostEscape = latitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{latitude}", with: latitudePostEscape, options: .literal, range: nil)
        let longitudePreEscape = "\(longitude)"
        let longitudePostEscape = longitudePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{longitude}", with: longitudePostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])

        let requestBuilder: RequestBuilder<ForecastPointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
